/* ======================================================================
**  mframer.cs -- This file is a part of C#Framer (Frame preprocessor for C#)
**  Version 1.08
** ======================================================================
**
** ======================================================================
**  This source code may not be used for commercial reasons.
**  Please, notify us, if you make any changes to this file.
**
**  Copyright (c) by Max Schlee. All rights reserved.
**  MS LeRM Laboratory 2003
**  www.geocities.com/mslerm
**  mslerm@gmx.de
** ======================================================================
*/
using System;

// ======================================================================
public class MFramer {
    private static String sm_pszID    = "001af56d-fa92-40d7-b9ee-1906a0f7f723";
    private static int    sm_nCounter = 0;

    private int     m_nObjectID;
    private MString m_mstrFrameText;

// ----------------------------------------------------------------------
    public MFramer()
    {
        m_nObjectID = sm_nCounter++;
    }

// ----------------------------------------------------------------------
    public String getFrameText() 
    {
        return MString.toString(m_mstrFrameText);
    }

// ----------------------------------------------------------------------
    public String getClassID()
    {
        return sm_pszID;
    }

// ----------------------------------------------------------------------
    public String getObjectID ()
    {
        return getClassID() + m_nObjectID;
    }

// ----------------------------------------------------------------------
    public String getClassName()
    {
        return "MFramer";
    }

// ----------------------------------------------------------------------
    public MFramer exportToFile(String str) 
    {
        m_mstrFrameText.exportToFile(str);
        return this;
    }

// ----------------------------------------------------------------------
    public MFramer exportToFile(MString mstr) 
    {
        m_mstrFrameText.exportToFile(mstr);
        return this;
    }

// ----------------------------------------------------------------------
    public MFramer importFromFile(String str) 
    {
        m_mstrFrameText.importFromFile(str);
        return this;
    }

// ----------------------------------------------------------------------
    public String setFrameText(String str) 
    {
        m_mstrFrameText = new MString(str);
        return MString.toString(m_mstrFrameText);
    }

// ----------------------------------------------------------------------
    public long length()
    {
        return m_mstrFrameText.length(); 
    }

} // public class MFramer {