/* ======================================================================
**  MString.cs -- This file is a part of C#Framer (Frame preprocessor for C#)
**  Version 1.12
** ======================================================================
**
** ======================================================================
**  This source code may not be used for commercial reasons.
**  Please, notify us, if you make any changes to this file.
**
**  Copyright (c) by Max Schlee. All rights reserved.
**  MS LeRM Laboratory 2003
**  www.geocities.com/mslerm
**  mslerm@gmx.de
** ======================================================================
*/
using System;
using System.IO;

// ======================================================================
public class MString {
    private static String sm_pszID    = "d82dd5bf-0364-4939-a1b2-147c360a6f19";
    private static int    sm_nCounter = 0;

    private int    m_nObjectID;
    private String m_strSourceString = "";

// ----------------------------------------------------------------------    
    public MString()
    {
        m_nObjectID = sm_nCounter++;
        m_strSourceString = "";
    }

// ----------------------------------------------------------------------    
    public MString(String str)
    {
        m_nObjectID = sm_nCounter++;
        m_strSourceString = str;
    }

// ----------------------------------------------------------------------
    public static String toString(int n)
    {
        return n.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(long l)
    {
        return l.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(char c)
    {
        return c.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(float f)
    {
        return f.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(double d)
    {
        return d.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(String str)
    {
        return str;
    }

// ----------------------------------------------------------------------
    public static String toString(bool b)
    {
        return b.ToString();
    }

// ----------------------------------------------------------------------
    public static String toString(MString mstr)
    {
        return mstr.m_strSourceString;
    }

// ----------------------------------------------------------------------
    public static String toString(MFramer mframer)
    {
        return mframer.getFrameText();
    }

// ----------------------------------------------------------------------
    public long length()
    {
        return m_strSourceString.Length; 
    }

// ----------------------------------------------------------------------
    public bool isEmpty()
    {
        return (m_strSourceString == "");
    }

// ----------------------------------------------------------------------
    public bool compare(MString mstr)
    {
        return (m_strSourceString == mstr.m_strSourceString);
    }

// ----------------------------------------------------------------------
    public bool compare(string str)
    {
        return (m_strSourceString == str);
    }

// ----------------------------------------------------------------------
    public MString toUpper()
    {
        m_strSourceString = m_strSourceString.ToUpper();
        return this;
    }

// ----------------------------------------------------------------------
    public MString toLower()
    {
        m_strSourceString = m_strSourceString.ToLower();
        return this;
    }

// ----------------------------------------------------------------------
    public String getClassID()
    {
        return sm_pszID;
    }

// ----------------------------------------------------------------------
    public String getObjectID ()
    {
        return getClassID() + m_nObjectID;
    }

// ----------------------------------------------------------------------
    public String getClassName()
    {
        return "MString";
    }

// ----------------------------------------------------------------------
    public MString importFromFile(String strFileName) 
    {

        FileStream   fs;
        BinaryReader br;
        int          i;

        try { 
            fs = new FileStream(strFileName, FileMode.Open);
            br = new BinaryReader(fs);

            byte[] bBuf = new byte [fs.Length]; 

            br.Read(bBuf, 0, (int)fs.Length);

            char ch;
            for (i = 0; i < (int)fs.Length; ++i) {
                ch                 = Convert.ToChar(bBuf[i]);
                m_strSourceString += ch;
            }

            fs.Close();
        }
        catch (Exception exc) {
            Console.WriteLine(exc.Message);
        }

        return this;
    }

// ----------------------------------------------------------------------
    public MString exportToFile(String strFileName) 
    {

        FileStream   fs;
        System.Int32 i;

        byte[] bBuf = new byte [m_strSourceString.Length]; 

        for (i = m_strSourceString.Length; --i >= 0; ) {
            bBuf[i] = (byte)m_strSourceString[i];
        }
        try { 
            fs = new FileStream(strFileName, FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fs);
            try {
                bw.Write(bBuf);
            }
            catch(Exception exc) {
                Console.WriteLine(exc.Message);
            }
            fs.Close();
        }
        catch (Exception exc) {
            Console.WriteLine(exc.Message);
        }
        return this;
    }

// ----------------------------------------------------------------------
    public MString exportToFile(MString mstr) 
    {
        exportToFile(toString(mstr));
        return this;
    }

} // public class MString