/* ======================================================================
**  mstring.h - String Suport
**  Version 2.27 XFramer Edition (www.geocities.com/mslerm/xframer)
** ======================================================================
**
** ======================================================================
**  This source code may not be used for commercial reasons.
**  Please, notify us, if you make any changes to this file.
**
**  Copyright (c) by Max Schlee. All rights reserved.
**  MS LeRM Laboratory 1998-2003
**  www.geocities.com/mslerm
**  mslerm@gmx.de
** ======================================================================
*/

#ifndef __MSTRING_H
#define __MSTRING_H

#if defined (NO_NAMESPACE)
    #include <iostream.h>
    #include <string.h>
    #include <stdio.h>
    #ifndef _IOSTREAM_
    #define _IOSTREAM_
    #endif
#elif defined(__BORLANDC__)
        #pragma warn -pia
        #include <iostream>
        #include <string>
        #include <stdio>
        using namespace std;
        #ifndef __IOSTREAM_H
        #define __IOSTREAM_H
        #endif
#elif defined(_MSC_VER)
    #if _MSC_VER >= 1100
        #pragma warning(disable : 4530)
        #include <string.h>
        #include <stdio.h>
        #include <iostream>
        using namespace std;
        #ifndef _INC_IOSTREAM
        #define _INC_IOSTREAM
        #endif
    #else
        #include <iostream.h>
        #include <string.h>
        #include <stdio.h>
        #ifndef _IOSTREAM_
        #define _IOSTREAM_
        #endif
    #endif
#else
    #include <iostream>
    #include <string>
    #include <stdio.h>
    using namespace std;
    #ifndef _IOSTREAM_H
    #define _IOSTREAM_H
    #endif
#endif

// ======================================================================
class MString {
protected:
    static const char*             sm_pszID;
    static       int               sm_nCounter;
                 int               m_nObjectID;
                 char*             m_pszSourceString;
                 long unsigned int m_liLength;
     
public:
            MString (const char* psz = ""          );
            MString (const char*, long unsigned int);
            MString (int,         long unsigned int);
            MString (const MString&                );
            MString (const int&                    );
            MString (const long&                   );
            MString (const char&                   );
            MString (const float&                  );
            MString (const double&                 );
            MString (const unsigned&               );
            MString (const long double&            );
    virtual ~MString(                              );

    virtual          MString& operator=   (const MString&);
    virtual const    MString& operator+=  (const MString&);
    virtual          MString  operator+   (const MString&);
    virtual          char&    operator[]  (const long&   );
    virtual const    char&    operator[]  (const long&   ) const;
    virtual          int      operator==  (const MString&) const;
    virtual          int      operator!=  (const MString&) const;

    virtual void     printOn       (ostream&              ) const;
    virtual int      isEmpty       (                      ) const;
    virtual MString  getString     (const int&, const int&) const;
    virtual MString& copy          (const char*           );
    virtual MString& copy          (const MString&        );
    virtual MString& cat           (const MString&        );
    virtual MString& concat        (const MString&        );
    virtual MString& reverse       (                      );
    virtual int      compare       (const MString&        ) const;
    virtual MString& toCStr        (                      );
    virtual MString& toUpper       (                      );
    virtual MString& toLower       (                      );
    virtual char*    getAddress    (                      );
    virtual MString& exportToFile  (const char*           );
    virtual MString& exportToFile  (MString&              );
    virtual MString& exportToStream(ostream&              );
    virtual MString& importFromFile(const char*           );
    virtual MString& importFromFile(MString mstr          );

    virtual int find (const MString&, const int& nStart = 0) const;

    virtual long unsigned int length () const;

// Commonality to EasyWinBGI3 Mirtus-Project (www.geocities.com/mslerm/winbgi)
    virtual MString  getClassID  () const;
    virtual MString  getObjectID () const;
    virtual MString  getClassName() const;
};

// ----------------------------------------------------------------------
//  MString attributes and methods
// ----------------------------------------------------------------------
const char* MString::sm_pszID    = "d9f791d6-f220-4b02-af56-e29786334034";
      int   MString::sm_nCounter = 0;

// ----------------------------------------------------------------------
MString::MString(const char* psz/*= ""*/) : m_pszSourceString(NULL)
                                          , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;
    copy(psz);
}

// ----------------------------------------------------------------------
MString::MString (const char* psz, long unsigned int li) : m_liLength(li)
{
    m_nObjectID = sm_nCounter++;

    m_pszSourceString = new char [m_liLength];

    long unsigned int i;
    for (i = 0; i < m_liLength; ++i) {
        m_pszSourceString[i] = psz[i];
    }
}

// ----------------------------------------------------------------------
MString::MString (int nInit, long unsigned int li) : m_liLength(li)
{
    m_nObjectID = sm_nCounter++;

    m_pszSourceString = new char [m_liLength];
}

// ----------------------------------------------------------------------
MString::MString(const MString& mstr) : m_pszSourceString(NULL)
                                      , m_liLength(mstr.m_liLength)
{
    m_nObjectID = sm_nCounter++;

    m_pszSourceString = new char [m_liLength];

    register int i;
    for (i = m_liLength; --i >= 0; ) {
        m_pszSourceString[i] = mstr.m_pszSourceString[i];
    }
}

// ----------------------------------------------------------------------
MString::MString(const int& n) : m_pszSourceString(NULL)
                               , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%d", n);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
MString::MString(const unsigned& n) : m_pszSourceString(NULL)
                                    , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%u", n);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
MString::MString(const long& n) : m_pszSourceString(NULL)
                                , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%d", n);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
MString::MString(const char& c) : m_pszSourceString(NULL)
                                , m_liLength(1)
{
    m_nObjectID = sm_nCounter++;

    m_pszSourceString = new char [m_liLength];

    m_pszSourceString[0] = c;
}

// ----------------------------------------------------------------------
MString::MString(const float& f) : m_pszSourceString(NULL)
                                 , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%f", f);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
MString::MString(const double& d) : m_pszSourceString(NULL)
                                  , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%f", d);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
MString::MString(const long double& d) : m_pszSourceString(NULL)
                                       , m_liLength(0)
{
    m_nObjectID = sm_nCounter++;

    char cBuffer[128];

    register int i;
    for (i = 128; --i >= 0;) {
        cBuffer[i] = 0;
    }
    ::sprintf(cBuffer, "%f", d);

    copy(cBuffer);
}

// ----------------------------------------------------------------------
/*virtual*/MString::~MString()
{
    sm_nCounter--;

    if (m_pszSourceString != NULL) {
        delete [] m_pszSourceString;
    }
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::operator=(const MString& mstr)
{
    copy(mstr);

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString MString::getClassName() const
{
    return "MString";
}

// ----------------------------------------------------------------------
/*virtual*/MString MString::getClassID() const
{
    return sm_pszID;
}

// ----------------------------------------------------------------------
/*virtual*/MString MString::getObjectID() const
{
    return getClassID() + (MString)m_nObjectID;
}

// ----------------------------------------------------------------------
/*virtual*/const MString& MString::operator+=(const MString& mstr)
{
    cat(mstr);

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::cat(const MString& mstr)
{
    char* pszSourceStringTemp = new char [m_liLength + mstr.m_liLength];

    if (m_pszSourceString != NULL) {
        register int i;
        for (i = 0; i < m_liLength; ++i) {
            pszSourceStringTemp[i] = m_pszSourceString[i];
        }

        delete m_pszSourceString;
 
        m_liLength       += mstr.m_liLength;
        m_pszSourceString = pszSourceStringTemp;

        register int j;
        for (j = 0; j < mstr.m_liLength; ++j, ++i) {
            m_pszSourceString[i] = mstr.m_pszSourceString[j];
        }
    }

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::concat(const MString& mstr)
{
    return cat(mstr);
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::copy(const MString& mstr)
{
    if (&mstr != this) {
        if (m_pszSourceString != NULL) {
            delete m_pszSourceString;
        }
        
        m_pszSourceString = new char [m_liLength = mstr.m_liLength];

        register int i;
        for (i = m_liLength; --i >= 0; ) {
            m_pszSourceString[i] = mstr.m_pszSourceString[i];
        }
    }

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::copy(const char* psz)
{
    if (m_pszSourceString != NULL) {
        delete m_pszSourceString;
    }

    m_pszSourceString = new char [m_liLength = ::strlen(psz)];

    register int i;
    for (i = m_liLength; --i >= 0; ) {
        m_pszSourceString[i] = psz[i];
    }

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::reverse()
{
    char cBuf;
    register long i;
    for (i = 0; i < (long)(m_liLength / 2); ++i) {
        cBuf                 = m_pszSourceString[i];
        m_pszSourceString[i] = m_pszSourceString[m_liLength - i - 1];

        m_pszSourceString[m_liLength - i - 1] = cBuf;
    }

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/int MString::compare(const MString& mstr) const
{
    int nResult = 0;
    
    if (m_liLength == mstr.m_liLength) {
        nResult = 1;
        register int i;
        for (i = m_liLength; --i >= 0; ) {
            if (m_pszSourceString[i] != mstr.m_pszSourceString[i]) {
                nResult = 0;
                break;
            }
        }
    }
    return nResult;
}

// ----------------------------------------------------------------------
/*virtual*/MString MString::operator+(const MString& strS)
{
    MString mstrTemp(*this);
    mstrTemp += strS;
    return  mstrTemp;
}

// ----------------------------------------------------------------------
/*virtual*/int MString::operator==(const MString& mstr) const
{
    return compare(mstr);
}

// ----------------------------------------------------------------------
/*virtual*/int MString::operator!=(const MString& mstr) const
{
    return !compare(mstr);
}

// ----------------------------------------------------------------------
/*virtual*/int MString::isEmpty() const
{
    return m_liLength == 0 ? 1 : 0;
}

// ----------------------------------------------------------------------
/*virtual*/int MString::find(const MString& mstr, 
                             const int&     nStart/*= 0*/
                            ) const
{
    register int          nTemp;
    register unsigned int i     = 0;
    register unsigned int j;

    for (j = nStart; j < m_liLength; ++j) {
        if (mstr.m_pszSourceString[i] == m_pszSourceString[j]) {
            i++;
            if (i == mstr.m_liLength) {
                nTemp = j - mstr.m_liLength + 1;
                break;
            }
        }
        else {
            nTemp = -1;
            i     = 0;
        }
    }
    return nTemp;
}

// ----------------------------------------------------------------------
/*virtual*/long unsigned int MString::length() const
{
    return m_liLength;
}

// ----------------------------------------------------------------------
/*virtual*/char& MString::operator[](const long& n)
{
    return m_pszSourceString[n];
}

// ----------------------------------------------------------------------
/*virtual*/const char& MString::operator[](const long& n) const
{
    return m_pszSourceString[n];
}

// ----------------------------------------------------------------------
/*virtual*/char* MString::getAddress() 
{
    return m_pszSourceString;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::toCStr()
{
    char* lpszTemp = new char [m_liLength + 1];

    register long i;
    for (i = m_liLength; --i >= 0; ) {
        lpszTemp[i] = m_pszSourceString[i];
    }
    lpszTemp[m_liLength] = 0;

    delete [] m_pszSourceString;

    m_pszSourceString = lpszTemp;
    
    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::toUpper()
{
    register long i;
    for (i = m_liLength; --i >= 0; ) {
        if (m_pszSourceString[i] < 0x7b && m_pszSourceString[i] > 0x60) {
            m_pszSourceString[i] -= 32;
        }
    }

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::toLower()
{
    register long i;
    for (i = m_liLength; --i >= 0; ) {
        if (m_pszSourceString[i] < 0x5b && m_pszSourceString[i] > 0x40) {
            m_pszSourceString[i] += 32;
        }
    }

    return *this;
}


// ----------------------------------------------------------------------
/*virtual*/MString MString::getString(const int& nBegin, 
                                      const int& nEnd
                                     ) const
{
    MString mstrTemp(0, nEnd - nBegin);

    register long i;
    register long j = 0;
    for (i = nBegin; i < nEnd; ++i) {
        mstrTemp.m_pszSourceString[j++] = m_pszSourceString[i];
    }

    return mstrTemp;
}


// ----------------------------------------------------------------------
/*virtual*/MString& MString::exportToFile(const char* lpsz)
{
    FILE* file;
    if(!(file = ::fopen(lpsz, "wb"))) {
        throw "can not create the file";
    }
    
    ::fwrite(m_pszSourceString, 1, m_liLength, file);

    ::fclose(file);

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::exportToFile(MString& mstr)
{
    exportToFile(mstr.toCStr().getAddress());
    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::importFromFile(const char* lpsz)
{
    FILE*  file;
    fpos_t fpos1;
    fpos_t fpos2;

    if(!(file = ::fopen(lpsz, "rb"))) {
        throw "can not open the file";
    }

    ::fgetpos(file, &fpos1);

    ::fseek(file, 0L, SEEK_END);
    ::fgetpos(file, &fpos2);

    ::fseek(file, (long)fpos1, SEEK_SET);

    m_liLength = (long)fpos2;

    if (m_pszSourceString != NULL) {
        delete [] m_pszSourceString;
    }

    m_pszSourceString = new char [m_liLength];

    ::fread(m_pszSourceString, 1, m_liLength, file);

    ::fclose(file);

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::importFromFile(MString mstr)
{
    importFromFile(mstr.toCStr().getAddress());
    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/MString& MString::exportToStream(ostream& output)
{
    char* psz = new char [m_liLength + 1];

    register int i;
    for (i = 0; i < m_liLength; ++i) {
        psz[i] = m_pszSourceString[i];
    }
    psz[i] = 0;

    output << psz;

    delete [] psz;

    return *this;
}

// ----------------------------------------------------------------------
/*virtual*/void MString::printOn(ostream& output) const
{
    char* psz = new char [m_liLength + 1];

    register int i;
    for (i = 0; i < m_liLength; ++i) {
        if (!m_pszSourceString[i]) {
            psz[i] = '\x20';
        }
        else {
            psz[i] = m_pszSourceString[i];
        }
    }
    psz[i] = 0;

    output << psz;

    delete [] psz;
}

// ----------------------------------------------------------------------
inline ostream& operator<<(ostream& output, const MString& mstr)
{
    mstr.printOn(output);
    return output;
}

// ======================================================================
//  Global MString functions
// ======================================================================
// ----------------------------------------------------------------------
MString operator+(const char* pc, const MString& mstr)
{
    return (MString)pc + mstr;
}

// ----------------------------------------------------------------------
template <class STLCollection>
MString toMString(STLCollection& collection) {
    MString mstrTemp;
  
    typename STLCollection::iterator i;

    for (i = collection.begin(); i != collection.end(); ++i) {
        mstrTemp += (MString) *i;
    }

    return mstrTemp;
}

#endif //__MSTRING_H
