//This Example01 based on Delta Software Technology GmbH. "Das ANGIE Frame-System". 
//internal paper, 2002

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
frame FrGenNumberElement {
    private String m_strName;
    private int    m_nMaxValue;
    private String m_strInitValue;

// ----------------------------------------------------------------------
    public FrGenNumberElement(String strName, int nMaxValue) 
    {
        m_strName      = strName;
        m_nMaxValue    = nMaxValue;
        m_strInitValue = "";
        
        updateFrame();
    }

// ----------------------------------------------------------------------
    public void updateFrame()
    {
        String strIntQualifer = (m_nMaxValue > 32767) ? "long" : "short";
BEGIN_FRAME_TEXT()
/* The following Number Element "<!m_strName!>" is generated
   by the frame "GenNumberElement" */
<!strIntQualifer!> int <!m_strName!><!m_strInitValue!>;
END_FRAME_TEXT()    
    }

// ----------------------------------------------------------------------
    public void setNumbersInitVal(String str)
    {
        m_strInitValue = str;
        updateFrame();
    }
}

// ======================================================================
public class Start {
    public static void main(String argv[])
    {
        FrGenNumberElement frgne1 = new FrGenNumberElement("aShortNumber", 100);
        frgne1.exportToFile("test1.txt");

        FrGenNumberElement frgne2 = new FrGenNumberElement("aLongNumber", 999000);
        frgne2.exportToFile("test2.txt");

        frgne2.setNumbersInitVal("= 100000");
        frgne2.exportToFile("test3.txt");
    }
}
