/* ======================================================================
**  MString.java -- This file is a part of JFramer (Frame preprocessor for Java)
**  Version 1.11
** ======================================================================
**
** ======================================================================
**  This source code may not be used for commercial reasons.
**  Please, notify us, if you make any changes to this file.
**
**  Copyright (c) by Max Schlee. All rights reserved.
**  MS LeRM Laboratory 2002-2003
**  www.geocities.com/mslerm
**  mslerm@gmx.de
** ======================================================================
*/
import java.io.*;

// ======================================================================
public class MString {
    private static String sm_pszID    = "3751062d-a2ee-4b52-9254-04a989c35c74";
    private static int    sm_nCounter = 0;

    private int    m_nObjectID;
    private String m_strSourceString = "";

// ----------------------------------------------------------------------    
    public MString()
    {
        m_nObjectID = sm_nCounter++;
        m_strSourceString = "";
    }


// ----------------------------------------------------------------------    
    public MString(String str)
    {
        m_nObjectID = sm_nCounter++;
        m_strSourceString = str;
    }

// ----------------------------------------------------------------------
    public static String toString(int n)
    {
        return String.valueOf(n);
    }

// ----------------------------------------------------------------------
    public static String toString(long l)
    {
        return String.valueOf(l);
    }

// ----------------------------------------------------------------------
    public static String toString(char c)
    {
        return String.valueOf(c);
    }

// ----------------------------------------------------------------------
    public static String toString(float f)
    {
        return String.valueOf(f);
    }

// ----------------------------------------------------------------------
    public static String toString(double d)
    {
        return String.valueOf(d);
    }

// ----------------------------------------------------------------------
    public static String toString(String str)
    {
        return str;
    }

// ----------------------------------------------------------------------
    public static String toString(MString mstr)
    {
        return mstr.m_strSourceString;
    }

// ----------------------------------------------------------------------
    public static String toString(MFramer mframer)
    {
        return mframer.getFrameText();
    }

// ----------------------------------------------------------------------
    public static String toString(boolean b)
    {
        return String.valueOf(b);
    }

// ----------------------------------------------------------------------
    public boolean isEmpty()
    {
        return (m_strSourceString == "");
    }

// ----------------------------------------------------------------------
    public boolean compare(MString mstr)
    {
        return (m_strSourceString == mstr.m_strSourceString);
    }

// ----------------------------------------------------------------------
    public boolean compare(String str)
    {
        return (m_strSourceString == str);
    }

// ----------------------------------------------------------------------
    public MString toUpper()
    {
        m_strSourceString = m_strSourceString.toUpperCase();
        return this;
    }

// ----------------------------------------------------------------------
    public MString toLower()
    {
        m_strSourceString = m_strSourceString.toLowerCase();
        return this;
    }

// ----------------------------------------------------------------------
    public long length()
    {
        return m_strSourceString.length(); 
    }

// ----------------------------------------------------------------------
    public String getClassID()
    {
        return sm_pszID;
    }

// ----------------------------------------------------------------------
    public String getObjectID ()
    {
        return getClassID() + m_nObjectID;
    }

// ----------------------------------------------------------------------
    public String getClassName()
    {
        return "MString";
    }

// ----------------------------------------------------------------------
    public MString importFromFile(String str) 
    {
        RandomAccessFile file;
        try {
            file = new RandomAccessFile(str, "r");

            int nSize = (int)file.length();

            byte[] cBuf = new byte[nSize];

            file.read(cBuf, 0, nSize);

            int i;

            m_strSourceString = "";
            for (i = 0; i < nSize; ++i) {
                m_strSourceString += (char)cBuf[i];
            }
            file.close();
       }
       catch(IOException ex) {
           ex.printStackTrace();
       }

        return this;
    }

// ----------------------------------------------------------------------
    public MString exportToFile(String str) 
    {
        RandomAccessFile file;
        FileWriter       fw;

        try {
            fw = new FileWriter(str);
            fw.close();

            file = new RandomAccessFile(str, "rw");

            byte[] cBuf = new byte[m_strSourceString.length()];

            int i;
            for (i = 0; i < m_strSourceString.length(); ++i) {
                cBuf[i] = (byte)m_strSourceString.charAt(i);
            }

            file.write(cBuf, 0, m_strSourceString.length());
            file.close();
       }
       catch(IOException ex) {
           ex.printStackTrace();
       }

        return this;
    }

// ----------------------------------------------------------------------
    public MString exportToFile(MString mstr) 
    {
        exportToFile(toString(mstr));
        return this;
    }

} // public class MString